' Add a reference to the System.Management.

Imports System.Management

Public Class Form1
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim os_searcher As New ManagementObjectSearcher("SELECT * FROM Win32_OperatingSystem")
        For Each mobj As ManagementObject In os_searcher.Get()
            GetValue(mobj, "BootDevice")
            GetValue(mobj, "BuildNumber")
            GetValue(mobj, "BuildType")
            GetValue(mobj, "Caption")
            GetValue(mobj, "CodeSet")
            GetValue(mobj, "CountryCode")
            GetValue(mobj, "CreationClassName")
            GetValue(mobj, "CSCreationClassName")
            GetValue(mobj, "CSDVersion")
            GetValue(mobj, "CSName")
            GetValue(mobj, "CurrentTimeZone")
            GetValue(mobj, "DataExecutionPrevention_Available")
            GetValue(mobj, "DataExecutionPrevention_32BitApplications")
            GetValue(mobj, "DataExecutionPrevention_Drivers")
            GetValue(mobj, "DataExecutionPrevention_SupportPolicy")
            GetValue(mobj, "Debug")
            GetValue(mobj, "Description")
            GetValue(mobj, "Distributed")
            GetValue(mobj, "EncryptionLevel")
            GetValue(mobj, "ForegroundApplicationBoost")
            GetValue(mobj, "FreePhysicalMemory")
            GetValue(mobj, "FreeSpaceInPagingFiles")
            GetValue(mobj, "FreeVirtualMemory")
            GetValue(mobj, "InstallDate")
            GetValue(mobj, "LargeSystemCache")
            GetValue(mobj, "LastBootUpTime")
            GetValue(mobj, "LocalDateTime")
            GetValue(mobj, "Locale")
            GetValue(mobj, "Manufacturer")
            GetValue(mobj, "MaxNumberOfProcesses")
            GetValue(mobj, "MaxProcessMemorySize")
            GetValue(mobj, "MUILanguages[]")
            GetValue(mobj, "Name")
            GetValue(mobj, "NumberOfLicensedUsers")
            GetValue(mobj, "NumberOfProcesses")
            GetValue(mobj, "NumberOfUsers")
            GetValue(mobj, "OperatingSystemSKU")
            GetValue(mobj, "Organization")
            GetValue(mobj, "OSArchitecture")
            GetValue(mobj, "OSLanguage")
            GetValue(mobj, "OSProductSuite")
            GetValue(mobj, "OSType")
            GetValue(mobj, "OtherTypeDescription")
            GetValue(mobj, "PAEEnabled")
            GetValue(mobj, "PlusProductID")
            GetValue(mobj, "PlusVersionNumber")
            GetValue(mobj, "Primary")
            GetValue(mobj, "ProductType")
            GetValue(mobj, "QuantumLength")
            GetValue(mobj, "QuantumType")
            GetValue(mobj, "RegisteredUser")
            GetValue(mobj, "SerialNumber")
            GetValue(mobj, "ServicePackMajorVersion")
            GetValue(mobj, "ServicePackMinorVersion")
            GetValue(mobj, "SizeStoredInPagingFiles")
            GetValue(mobj, "Status")
            GetValue(mobj, "SuiteMask")
            GetValue(mobj, "SystemDevice")
            GetValue(mobj, "SystemDirectory")
            GetValue(mobj, "SystemDrive")
            GetValue(mobj, "TotalSwapSpaceSize")
            GetValue(mobj, "TotalVirtualMemorySize")
            GetValue(mobj, "TotalVisibleMemorySize")
            GetValue(mobj, "Version")
            GetValue(mobj, "WindowsDirectory")
        Next mobj

        For Each col As ColumnHeader In lvwResults.Columns
            col.Width = -2
        Next col
    End Sub

    Private Sub GetValue(ByVal mobj As ManagementObject, ByVal property_name As String)
        Dim value As String
        Try
            value = mobj(property_name).ToString()
        Catch ex As Exception
            value = "*** Error: " & ex.Message
        End Try

        lvwResults.Items.Add(property_name).SubItems.Add(value)
    End Sub

End Class
